=== debian/changelog ===
nheko (0.8.0+really0.7.2-4) unstable; urgency=medium

  * debian/control, patches/no_tweeny:
    * Don't use tweeny, to avoid a compiler error in gcc-10. (Closes: #986519)

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 15 Apr 2021 17:10:18 -0400
