=== debian/control ===
Source: nheko
Section: net
Priority: optional
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
Uploaders: Hubert Chathi <uhoreg@debian.org>
Build-Depends: cmake (>= 3.15)
 , debhelper-compat (=12)
 , dh-exec
 , libboost-dev (>= 1.70)
 , libboost-atomic-dev (>= 1.70)
 , libboost-chrono-dev (>= 1.70)
 , libboost-date-time-dev (>= 1.70)
 , libboost-iostreams-dev (>= 1.70)
 , libboost-random-dev (>= 1.70)
 , libboost-regex-dev (>= 1.70)
 , libboost-system-dev (>= 1.70)
 , libboost-thread-dev (>= 1.70)
 , libcmark-dev (>= 0.29)
 , liblmdb++-dev
 , libolm-dev (>= 3.0~)
 , libqt5svg5-dev
 , libspdlog-dev (>= 1.5.0+ds-4)
 , libsodium-dev
 , libssl-dev
 , nlohmann-json3-dev (>= 3.7.0-2~)
 , qtbase5-dev (>= 5.10)
 , qtdeclarative5-dev
 , libfmt-dev
 , qtquickcontrols2-5-dev
 , qtmultimedia5-dev
 , qttools5-dev
 , zlib1g-dev
Standards-Version: 4.5.0
Homepage: https://github.com/Nheko-Reborn/nheko
Vcs-Git: https://salsa.debian.org/matrix-team/nheko.git
Vcs-Browser: https://salsa.debian.org/matrix-team/nheko

Package: nheko
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
 , qml-module-qt-labs-settings
 , qml-module-qtgraphicaleffects
 , qml-module-qtmultimedia
 , qml-module-qtquick2
 , qml-module-qtquick-controls2
 , qml-module-qtquick-layouts
 , qml-module-qtquick-window2
Recommends: ca-certificates, fonts-noto-color-emoji
Description: desktop IM client for the Matrix protocol
 Nheko is a Qt-based chat client for Matrix, an open, federated communications
 protocol.  The motivation behind the project is to provide a native desktop
 app for Matrix that feels more like a mainstream chat app and less like an IRC
 client.
