=== debian/changelog ===
nheko (0.9.1-1) unstable; urgency=medium

  * New upstream release.

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 22 Feb 2022 19:15:22 -0500

nheko (0.9.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/disambiguate_olmerrorcode: removed -- no longer needed.

 -- Hubert Chathi <uhoreg@debian.org>  Fri, 03 Dec 2021 14:18:39 -0500

nheko (0.8.2-2) unstable; urgency=medium

  * debian/control: Add missing QML dependency. (Closes: #990351)
  * debian/patches/disambiguate_olmerrorcode: Fix build with newer libolm.

 -- Hubert Chathi <uhoreg@debian.org>  Sat, 16 Oct 2021 14:42:04 -0400

nheko (0.8.2-1) experimental; urgency=medium

  [ Pirate Praveen ]

  * debian/control: Add missing gstreamer dependencies. (Closes: #981104)

  [ Hubert Chathi ]

  * New upstream release. (Closes: #981525)
  * debian/control: update with new build-depends
  * debian/patches/no_find_tweeny: removed -- not needed any more.

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 11 May 2021 16:26:27 -0400

nheko (0.8.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    * add build-depends on gstreamer

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 20 Jan 2021 14:07:37 -0500
