=== debian/control ===
--- 
+++ 
@@ -6,23 +6,22 @@
 Build-Depends: cmake (>= 3.15)
  , debhelper-compat (=12)
  , dh-exec
- , libboost-dev (>= 1.70)
- , libboost-atomic-dev (>= 1.70)
- , libboost-chrono-dev (>= 1.70)
- , libboost-date-time-dev (>= 1.70)
- , libboost-iostreams-dev (>= 1.70)
- , libboost-random-dev (>= 1.70)
- , libboost-regex-dev (>= 1.70)
- , libboost-system-dev (>= 1.70)
- , libboost-thread-dev (>= 1.70)
  , libcmark-dev (>= 0.29)
- , liblmdb++-dev
+ , libcurl4-openssl-dev
+ , libevent-dev
+ , libgstreamer1.0-dev (>= 1.18.0)
+ , libgstreamer-plugins-base1.0-dev (>= 1.18.0)
+ , libgstreamer-plugins-bad1.0-dev (>= 1.18.0)
+ , liblmdb-dev
+ , libnice-dev
  , libolm-dev (>= 3.0~)
  , libqt5svg5-dev
  , libspdlog-dev (>= 1.5.0+ds-4)
  , libsodium-dev
  , libssl-dev
+ , libxcb-ewmh-dev
  , nlohmann-json3-dev (>= 3.7.0-2~)
+ , qt5keychain-dev
  , qtbase5-dev (>= 5.10)
  , qtdeclarative5-dev
  , libfmt-dev
@@ -38,6 +37,7 @@
 Package: nheko
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+ , qml-module-qt-labs-platform
  , qml-module-qt-labs-settings
  , qml-module-qtgraphicaleffects
  , qml-module-qtmultimedia
@@ -45,6 +45,9 @@
  , qml-module-qtquick-controls2
  , qml-module-qtquick-layouts
  , qml-module-qtquick-window2
+ , gstreamer1.0-nice
+ , gstreamer1.0-qt5
+ , gstreamer1.0-vaapi
 Recommends: ca-certificates, fonts-noto-color-emoji
 Description: desktop IM client for the Matrix protocol
  Nheko is a Qt-based chat client for Matrix, an open, federated communications
