## nheko 0.9.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,12 @@
 option(ASAN "Compile with address sanitizers" OFF)
 option(QML_DEBUGGING "Enable qml debugging" OFF)
 option(COMPILE_QML "Compile Qml. It will make Nheko faster, but you will need to recompile it, when you update Qt." OFF)
+if(UNIX AND NOT APPLE)
+	option(MAN "Build man page" ON)
+else()
+	option(MAN "Build man page" OFF)
+endif()
+option(FLATPAK "Set this only if Nheko is built as a flatpak" OFF)
 
 set(
 	CMAKE_TOOLCHAIN_FILE "${CMAKE_CURRENT_LIST_DIR}/toolchain.cmake"
@@ -100,7 +106,7 @@
 
 set(CPACK_PACKAGE_VERSION_MAJOR "0")
 set(CPACK_PACKAGE_VERSION_MINOR "9")
-set(CPACK_PACKAGE_VERSION_PATCH "1")
+set(CPACK_PACKAGE_VERSION_PATCH "3")
 set(PROJECT_VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR})
 set(PROJECT_VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR})
 set(PROJECT_VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH})
@@ -111,7 +117,7 @@
 
 # Set additional project information
 set(COMPANY "Nheko")
-set(COPYRIGHT "Copyright (c) 2021 Nheko Contributors")
+set(COPYRIGHT "Copyright (c) 2022 Nheko Contributors")
 set(IDENTIFIER "io.github.nheko-reborn.nheko")
 
 add_project_meta(META_FILES_TO_INCLUDE)
@@ -305,9 +311,6 @@
 	# Dialogs
 	src/dialogs/CreateRoom.cpp
 	src/dialogs/FallbackAuth.cpp
-	src/dialogs/ImageOverlay.cpp
-	src/dialogs/Logout.cpp
-	src/dialogs/PreviewUploadOverlay.cpp
 	src/dialogs/ReCaptcha.cpp
 
 	# Emoji
@@ -324,30 +327,19 @@
 	src/timeline/TimelineModel.cpp
 	src/timeline/DelegateChooser.cpp
 	src/timeline/Permissions.cpp
+	src/timeline/PresenceEmitter.cpp
 	src/timeline/RoomlistModel.cpp
 
 	# UI components
-	src/ui/Badge.cpp
-	src/ui/DropShadow.cpp
-	src/ui/FlatButton.cpp
-	src/ui/FloatingButton.cpp
-	src/ui/InfoMessage.cpp
-	src/ui/Label.cpp
-	src/ui/LoadingIndicator.cpp
+	src/ui/HiddenEvents.cpp
 	src/ui/MxcAnimatedImage.cpp
 	src/ui/MxcMediaProxy.cpp
 	src/ui/NhekoCursorShape.cpp
+	src/ui/NhekoEventObserver.cpp
 	src/ui/NhekoDropArea.cpp
 	src/ui/NhekoGlobalObject.cpp
-	src/ui/OverlayModal.cpp
-	src/ui/OverlayWidget.cpp
-	src/ui/RaisedButton.cpp
-	src/ui/Ripple.cpp
-	src/ui/RippleOverlay.cpp
 	src/ui/RoomSettings.cpp
-	src/ui/SnackBar.cpp
 	src/ui/TextField.cpp
-	src/ui/TextLabel.cpp
 	src/ui/Theme.cpp
 	src/ui/ThemeManager.cpp
 	src/ui/ToggleButton.cpp
@@ -394,7 +386,6 @@
 	src/RoomDirectoryModel.cpp
 	src/RoomsModel.cpp
 	src/Utils.cpp
-	src/WelcomePage.cpp
 	src/main.cpp
 
 	third_party/blurhash/blurhash.cpp
@@ -413,11 +404,18 @@
 	FetchContent_Declare(
 		MatrixClient
 		GIT_REPOSITORY https://github.com/Nheko-Reborn/mtxclient.git
-		GIT_TAG        v0.6.1
+		GIT_TAG        v0.7.0
 		)
 	set(BUILD_LIB_EXAMPLES OFF CACHE INTERNAL "")
 	set(BUILD_LIB_TESTS OFF CACHE INTERNAL "")
 	FetchContent_MakeAvailable(MatrixClient)
 else()
-	find_package(MatrixClient 0.6.1 REQUIRED)
-endif()
+	find_package(MatrixClient 0.6.2 REQUIRED)
+endif()
+if(USE_BUNDLED_OLM)
+	include(FetchContent)
+	FetchContent_Declare(
+		Olm
+		GIT_REPOSITORY https://gitlab.matrix.org/matrix-org/olm.git
+		GIT_TAG        3.2.8
+		)
