=== debian/changelog ===
nheko (0.9.3-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Pirate Praveen <praveen@debian.org>  Fri, 24 Jun 2022 19:54:56 +0530

nheko (0.9.3-2) unstable; urgency=medium

  * debian/control: Add some missing dependencies.  Thanks to Pablo Barciela.

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 08 Jun 2022 10:34:29 -0400

nheko (0.9.3-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Pirate Praveen <praveen@debian.org>  Fri, 17 Jun 2022 12:10:08 +0530

nheko (0.9.3-1) unstable; urgency=medium

  * New upstream release.

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 07 Jun 2022 13:23:39 -0400
