=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: optional
 Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
 Uploaders: Hubert Chathi <uhoreg@debian.org>
-Build-Depends: cmake (>= 3.15)
+Build-Depends: asciidoc-base
+ , cmake (>= 3.15)
  , debhelper-compat (=12)
  , dh-exec
  , libcmark-dev (>= 0.29)
@@ -37,6 +38,8 @@
 Package: nheko
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+ , libqt5multimedia5-plugins
+ , qml-module-qt-labs-animation
  , qml-module-qt-labs-platform
  , qml-module-qt-labs-settings
  , qml-module-qtgraphicaleffects
